#include "xparameters.h"
#include "xil_exception.h"
#include <stdio.h>
#include "platform.h"
#include "xil_cache.h"
#include "xscugic.h"
#include "xil_exception.h"

int ScuGicInterruptSetup(XScuGic *IntcInstancePtr, u16 DeviceId);
/**************************** Type Definitions *******************************/

/***************** Macros (Inline Functions) Definitions *********************/

/************************** Function Prototypes ******************************/

static void cnt_handler();

XScuGic intc;

int main(void)
{
    int Status;


    Status = ScuGicInterruptSetup(&intc, XPAR_PS7_SCUGIC_0_DEVICE_ID);
    if (Status == 0) {
        print("ScuGic Interrupt Setup PASSED\r\n");
    } 
    else {
        print("ScuGic Interrupt Setup FAILED\r\n");
    } 

    while(1) {
    }

    return XST_SUCCESS;
}

void cnt_handler0()
{
    xil_printf(".");
}

void cnt_handler1()
{
    xil_printf("/");
}

void cnt_handler2()
{
    xil_printf("}");
}

int ScuGicInterruptSetup(XScuGic *IntcInstancePtr, u16 DeviceId)
{
    int Status;
    static XScuGic_Config *GicConfig;

    /*
     * Initialize the interrupt controller driver so that it is ready to
     * use.
     */
    GicConfig = XScuGic_LookupConfig(DeviceId);
    if (NULL == GicConfig) {
        return XST_FAILURE;
    }

    Status = XScuGic_CfgInitialize(IntcInstancePtr, GicConfig, GicConfig->CpuBaseAddress);
    if (Status != XST_SUCCESS) {
        return XST_FAILURE;
    }

	Status = XScuGic_Connect(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN0_INTR , (Xil_ExceptionHandler) cnt_handler0, NULL);
	Status = XScuGic_Connect(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN1_INTR , (Xil_ExceptionHandler) cnt_handler1, NULL);
	Status = XScuGic_Connect(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN2_INTR , (Xil_ExceptionHandler) cnt_handler2, NULL);

	if (Status != XST_SUCCESS) {
        print("XScuGic_Connect FAILED\r\n");
        while(1);
	}
    else {
        print("XScuGic_Connect PASSED\r\n");
    }

	XScuGic_SetPriorityTriggerType(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN0_INTR , 0, 3);
	XScuGic_SetPriorityTriggerType(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN1_INTR , 1, 3);
	XScuGic_SetPriorityTriggerType(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN2_INTR , 2, 3);


    XScuGic_Enable(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN0_INTR);
    XScuGic_Enable(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN1_INTR);
    XScuGic_Enable(IntcInstancePtr, XPAR_FABRIC_SYSTEM_IN2_INTR);


    Xil_ExceptionInit();

    Xil_ExceptionRegisterHandler(XIL_EXCEPTION_ID_IRQ_INT, (Xil_ExceptionHandler)XScuGic_InterruptHandler, IntcInstancePtr);
	Xil_ExceptionEnable();
    return XST_SUCCESS;
}


